Option Strict On

Namespace TreeViewAdaptors.MessageQueue
    Public Class MessageQueuesByMachineAdapter
        Inherits BaseTreeViewAdapter

        Dim m_strMachineName As String
        Dim m_arrLocalQueues As New ArrayList()

        Sub New(ByVal machineName As String)
            m_strMachineName = machineName
            Dim objMessageQueue As System.Messaging.MessageQueue

            ' Iterate through each Message Queue on the given machine
            For Each objMessageQueue In System.Messaging.MessageQueue.GetPrivateQueuesByMachine(machineName)
                ' Store each Message Queue in a local Array
                m_arrLocalQueues.Add(objMessageQueue)
            Next

        End Sub
        Public Overrides ReadOnly Property Label() As String
            Get
                Return m_strMachineName
            End Get
        End Property
    End Class

    Public Class MessageQueuesByTypeAdaptor
        Inherits BaseTreeViewAdapter

        Dim m_strLabel As String
        Dim m_objMQ As System.Messaging.MessageQueue

        Sub New(ByVal path As String)
            m_objMQ = New System.Messaging.MessageQueue(path)
            m_strLabel = Right(m_objMQ.FormatName, m_objMQ.FormatName.Length - InStr(1, m_objMQ.FormatName, "$"))

            ' Now for each Message Queue in this Queue Type (ie .\private$) add them to the collection
            for each objMessageQueue in m_objmq.GetPrivateQueuesByMachine(
        End Sub

        Public Overrides ReadOnly Property Label() As String
            Get
                Return m_strLabel
            End Get
        End Property
    End Class
    Public Class MessageQueueAdapter
        Inherits BaseTreeViewAdapter

        Dim m_strQueueName As String

        Sub New(ByVal queuePath As String)
            m_strQueueName = Right(queuePath, Len(queuePath) - InStrRev(queuePath, "\"))

        End Sub
        Public Overrides ReadOnly Property Label() As String
            Get
                Return "Message Queues"
            End Get
        End Property
    End Class
End Namespace
