Public Class TreeViewer
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents trvTreeView As System.Windows.Forms.TreeView
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.trvTreeView = New System.Windows.Forms.TreeView()
        Me.SuspendLayout()
        '
        'trvTreeView
        '
        Me.trvTreeView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.trvTreeView.ImageIndex = -1
        Me.trvTreeView.Name = "trvTreeView"
        Me.trvTreeView.SelectedImageIndex = -1
        Me.trvTreeView.Size = New System.Drawing.Size(432, 440)
        Me.trvTreeView.TabIndex = 0
        '
        'TreeView
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.trvTreeView})
        Me.Name = "TreeView"
        Me.Size = New System.Drawing.Size(432, 440)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub AppendObject(ByVal path As String, ByVal Adapter As BaseTreeViewAdapter)
        Dim objTVH As New TreeViewHelper()
        Dim objCurrentNode As TreeNode

        objCurrentNode = objTVH.SearchPath(path, Me.trvTreeView)
        objCurrentNode = Me.AppendItem(Adapter, objCurrentNode)

        Dim objSubItem As ITreeViewAdapter
        For Each objSubItem In Adapter
            Me.AppendItem(objSubItem, objCurrentNode)
        Next
    End Sub
    Public Sub AppendObject(ByVal Adapter As ITreeViewAdapter)
        ' Apply a default path of the root.
        Me.AppendObject("\", Adapter)
    End Sub
    Private Function AppendItem(ByVal item As ITreeViewAdapter, ByVal CurrentNode As TreeNode) As TreeNode
        Dim objNode As TreeNode
        objNode = CurrentNode.Nodes.Add(item.Label)
        objNode.Tag = item
        Return objNode
    End Function
End Class

Public Class TreeViewHelper
    Function SearchPath(ByVal path As String, ByVal treeView As TreeView) As TreeNode
        Dim strLabel As String
        Dim objPathNode As TreeNode

        objPathNode = treeView.TopNode
        For Each strLabel In path.Split("\")
            If objPathNode Is Nothing Then
                ' We haven't created any nodes yet
                objPathNode = treeView.Nodes.Add(strLabel)
            Else
                objPathNode = LocatePath(strLabel, objPathNode)
            End If
        Next
        Return objPathNode
    End Function

    Private Function LocatePath(ByVal Label As String, ByVal treeNode As TreeNode) As TreeNode
        Dim objNode As TreeNode

        For Each objNode In treeNode.Nodes
            If objNode.Text = Label Then
                Return objNode
                Exit For
            End If
        Next

        If objNode Is Nothing Then
            ' If we have reached this far then we can't find the label
            ' so we will create it.
            Return treeNode.Nodes.Add(Label)

        End If

    End Function
End Class