Option Strict On

Imports System.Messaging
Imports Sales

Public Class Example3
    Shared Sub Main()
        ' Example 2: Sending a full object as a message
        Dim objMessageQueue As MessageQueue
        Try
            objMessageQueue = New MessageQueue(Constants.MQ.LocalNonTransQueue)
            ' Create an instance of the simple Order Class and populate
            Dim objOrder As New Order()
            objOrder.CustomerID = "ALFKI"
            With objOrder.OrderDetails.Add()
                .ProductID = 1
                .Quantity = 99
                .UnitPrice = 17.5
                .Discount = 0
            End With
            With objOrder.OrderDetails.Add()
                .ProductID = 2
                .Quantity = 20
                .UnitPrice = 18
                .Discount = 0
            End With

            Dim objMessage As New Message()
            With objMessage
                .Body = objOrder
                .Priority = MessagePriority.Highest
                .Recoverable = True ' ** Only Line Different from Example2 **
            End With
            ' Send Message as Binary
            objMessage.Formatter = New BinaryMessageFormatter()
            ' Prefix the Label with its datatype so we can see it clearly
            objMessage.Label = "(Example3)Binary - Order:" & objOrder.CustomerID
            objMessageQueue.Send(objMessage)
            ' Now Send Message as XML
            objMessage.Formatter = New XmlMessageFormatter()

            objMessage.Label = "(Example3)XML - Order:" & objOrder.CustomerID
            objMessageQueue.Send(objMessage)
            MessageBox.Show("Message Sent")
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
            Stop
        Finally
            objMessageQueue.Close()
        End Try
    End Sub
End Class

