Option Strict On

Imports System.Messaging

Public Class frmQueueMonitor
    Inherits System.Windows.Forms.Form
    Public Delegate Function MonitorStart(ByVal queuePath As String) As Boolean
    Dim m_delMonitor As MonitorStart
    Public WithEvents m_objMonitor As New MonitorQueue()

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnMonitor As System.Windows.Forms.Button
    Friend WithEvents btnStop As System.Windows.Forms.Button
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents lblMessageCount As System.Windows.Forms.Label
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnMonitor = New System.Windows.Forms.Button()
        Me.lblMessageCount = New System.Windows.Forms.Label()
        Me.btnStop = New System.Windows.Forms.Button()
        Me.btnClose = New System.Windows.Forms.Button()
        Me.lblStatus = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'btnMonitor
        '
        Me.btnMonitor.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.btnMonitor.Location = New System.Drawing.Point(8, 96)
        Me.btnMonitor.Name = "btnMonitor"
        Me.btnMonitor.Size = New System.Drawing.Size(104, 23)
        Me.btnMonitor.TabIndex = 0
        Me.btnMonitor.Text = "Start Monitor"
        '
        'lblMessageCount
        '
        Me.lblMessageCount.Location = New System.Drawing.Point(24, 24)
        Me.lblMessageCount.Name = "lblMessageCount"
        Me.lblMessageCount.Size = New System.Drawing.Size(208, 23)
        Me.lblMessageCount.TabIndex = 1
        Me.lblMessageCount.Text = "Messages: 0"
        '
        'btnStop
        '
        Me.btnStop.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.btnStop.Location = New System.Drawing.Point(120, 96)
        Me.btnStop.Name = "btnStop"
        Me.btnStop.Size = New System.Drawing.Size(104, 23)
        Me.btnStop.TabIndex = 2
        Me.btnStop.Text = "Stop Monitor"
        '
        'btnClose
        '
        Me.btnClose.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me.btnClose.Location = New System.Drawing.Point(360, 96)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(104, 23)
        Me.btnClose.TabIndex = 3
        Me.btnClose.Text = "Close"
        '
        'lblStatus
        '
        Me.lblStatus.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lblStatus.Location = New System.Drawing.Point(24, 56)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(440, 23)
        Me.lblStatus.TabIndex = 4
        Me.lblStatus.Text = "Status: Not Monitoring"
        '
        'frmQueueMonitor
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(472, 128)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblStatus, Me.btnClose, Me.btnStop, Me.lblMessageCount, Me.btnMonitor})
        Me.Name = "frmQueueMonitor"
        Me.Text = "QueueMonitor"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_strMonitoredQueue As String

    Private Sub btnMonitor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMonitor.Click
        m_delMonitor = AddressOf m_objMonitor.Start
        m_delMonitor.BeginInvoke(m_strMonitoredQueue, AddressOf MonitorComplete, Nothing)
        Me.lblStatus.Text = "Status: Monitoring - " & m_strMonitoredQueue
    End Sub
    Private Sub MonitorComplete(ByVal ar As IAsyncResult)
        Dim blnError As Boolean = Not m_delMonitor.EndInvoke(ar)

        ' This is a very basic error reporting message, its not suggested you follow this!
        If Not blnError Then
            MessageBox.Show("Message Queue monitor has finished  with no errors")
        Else
            MessageBox.Show("Message Queue monitor has finished  with errors!")
        End If
        Me.lblStatus.Text = "Status: Not Monitoring"
        Me.Text = "Queue Monitor"
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        m_objMonitor.Monitor = False
    End Sub

    Private Sub m_objMonitor_OnMessageArrive(ByVal messageCount As Integer) Handles m_objMonitor.OnMessageArrive
        Me.lblStatus.Text = "Message Count: " & messageCount
        MessageBox.Show("You have mail.")
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Public Sub MonitorQueue(ByVal queuePath As String)
        m_strMonitoredQueue = queuePath
        Me.Text = "Queue Monitor: " & m_strMonitoredQueue
        Me.Show()
    End Sub
End Class

' This is the Class that will be run Async

Public Class MonitorQueue
    Public Event OnMessageArrive(ByVal messageCount As Integer)

    Private m_blnStop As Boolean = True

    Function Start(ByVal queuePath As String) As Boolean
        Dim intMessageCount As Integer

        ' Ensure that we set Monitor
        Me.Monitor = True
        Try
            Dim objMQ As New MessageQueue(queuePath)
            Do While Me.Monitor
                ' Check if we have a different message count ie New Message
                If intMessageCount < objMQ.GetAllMessages.Length Then
                    ' We have new messages
                    intMessageCount = objMQ.GetAllMessages.Length
                    RaiseEvent OnMessageArrive(intMessageCount)
                End If
                System.Threading.Thread.Sleep(10) ' Reduce the stress on the computer and sleep for a bit
            Loop
            Return True
        Catch ex As Exception
            ' An error happened so we will simply return false back to the application
            Return False
        End Try
    End Function

    Property Monitor() As Boolean
        Get
            Return m_blnStop
        End Get
        Set(ByVal Value As Boolean)
            m_blnStop = Value
        End Set
    End Property
End Class

